#include <avr\io.h>
#include "uart.h"

void UART_init(void)
{
	UBRRH = 0;
	UBRRL = 103;
	UCSRB |= _BV(RXEN) | _BV(TXEN);
	UCSRC |= _BV(URSEL) | _BV(UCSZ1) | _BV(UCSZ0);
}

int UART_putchar(char c, FILE * file)
{
	if(c == '\n') UART_putchar('\r', file);
	
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
	
	return 1;
}

int UART_getchar(FILE * file)
{
	loop_until_bit_is_set(UCSRA, RXC);
	char c = UDR;
	
	if(c == '\r') c = '\n';
	UART_putchar(c, file);
	
	return c;
}
