//****************************************************************************************
//****************************************************************************************
//  Project Name:		TCP/IP DRIVER
//						ICMP (INTERNET CONTROL MESSAGE PROTOCOL) C CODE HEADER FILE
//  Copyright:			EMBEDDED-CODE.COM
//
//  Licenced To:        NONE
//  Licence Number:     NONE
//
//  IMPORTANT: These files are copyright of embedded-code.com and are subject to a licence
//  agreement.  All rights reserved.  Unauthorised use, reproduction or distribution of
//  these files may lead to prosecution.
//  Any use in violation of the licence restrictions may subject the user to criminal
//  sanctions under applicable laws, as well as to civil liability for the breach of the
//  terms and conditions of the license.
//  This software is provided in an "as is" condition. No warranties, whether express,
//  implied or statutory, including, but not limited to, implied warranties of
//  merchantability and fitness for a particular purpose apply to this software. 
//  Embedded-code.com shall not be liable in any circumstances for special, incidental
//  or consequential damages, for any reason whatsoever.
//  Please see www.embedded-code.com/licence.php for full details.
//  This file contains hidden markers to identify it uniquely to the licence number it was
//  purchased under.
//  DO NOT REMOVE THIS NOTICE - IT IS A REQUIREMENT OF THE LICENCE AGREEMENT.
//****************************************************************************************
//****************************************************************************************


//##################################
//##################################
//########## USING DRIVER ##########
//##################################
//##################################

//###########################################
//##### DEALING WITH ICMP ECHO REQUESTS #####
//###########################################
//ICMP ECHO Requests are automatically dealt with by the stack - no user application intervention is required



//For further information please see the project technical manual





//*****************************
//*****************************
//********** DEFINES **********
//*****************************
//*****************************
#ifndef ICMP_C_INIT		//(Do only once)
#define	ICMP_C_INIT


#include "eth-main.h"


#define ICMP_MAX_DATA_LENGTH	32


//ICMP HEADER CODES:-
#define ICMP_ECHO_REQUEST		8
#define	ICMP_ECHO_REPLY			0


//----- DATA TYPE DEFINITIONS -----
typedef struct _ICMP_HEADER
{
	BYTE		type;
	BYTE		code;
	WORD		checksum;
	WORD		identifier;
	WORD		sequence_number;
} ICMP_HEADER;

#endif



//*******************************
//*******************************
//********** FUNCTIONS **********
//*******************************
//*******************************
#ifdef ICMP_C				//(Defined only by associated C file)
//-----------------------------------
//----- INTERNAL ONLY FUNCTIONS -----
//-----------------------------------


//-----------------------------------------
//----- INTERNAL & EXTERNAL FUNCTIONS -----
//-----------------------------------------
//(Also defined below as extern)
BYTE icmp_process_received_echo_request (WORD *icmp_id, WORD *icmp_sequence, BYTE *icmp_data_buffer, WORD data_remaining_bytes);
void icmp_send_packet(DEVICE_INFO *remote_device_info,BYTE icmp_packet_type, BYTE *data_buffer, WORD data_length, WORD *icmp_id, WORD *icmp_sequence);


#else
//------------------------------
//----- EXTERNAL FUNCTIONS -----
//------------------------------
extern BYTE icmp_process_received_echo_request (WORD *icmp_id, WORD *icmp_sequence, BYTE *icmp_data_buffer, WORD data_remaining_bytes);
extern void icmp_send_packet(DEVICE_INFO *remote_device_info,BYTE icmp_packet_type, BYTE *data_buffer, WORD data_length, WORD *icmp_id, WORD *icmp_sequence);


#endif




//****************************
//****************************
//********** MEMORY **********
//****************************
//****************************
#ifdef ICMP_C				//(Defined only by associated C file)
//--------------------------------------------
//----- INTERNAL ONLY MEMORY DEFINITIONS -----
//--------------------------------------------


//--------------------------------------------------
//----- INTERNAL & EXTERNAL MEMORY DEFINITIONS -----
//--------------------------------------------------
//(Also defined below as extern)


#else
//---------------------------------------
//----- EXTERNAL MEMORY DEFINITIONS -----
//---------------------------------------


#endif










