#ifndef _PCD8544_LCD_H_
#define _PCD8544_LCD_H_


//#define LCD_SPI_CONNECTION

#ifdef LCD_SPI_CONNECTION
#define LCD_DDR				DDRB
#define LCD_PORT			PORTB
#define LED					PB2
#define RST					PB3
#define SCE					PB4
#define MOSI				PB5
#define DC					PB6
#define SCK					PB7
#else

#define LCD_DDR				DDRC
#define LCD_PORT			PORTC
#define LED					PC2
#define RST					PC3
#define SCE					PC4
#define MOSI				PC6
#define DC					PC5
#define SCK					PC7
#endif

// LCD commands
#define LCD_INVERSE_MODE	0x0D
#define LCD_NORMAL_MODE		0x0C

 
/**
 * Function prototypes
 */
void LCD_init(void);
void LCD_clear(void);
void LCD_update (void);
void LCD_goto(unsigned char x, unsigned char y);
unsigned char LCD_putchar(unsigned char character);
unsigned char LCD_write(unsigned char data);
void LCD_command(unsigned char command);
void LCD_putstr(const char *string);
void LCD_setpixel(unsigned char x, unsigned char y);
void LCD_clearpixel(unsigned char x, unsigned char y);
void LCD_line(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);
void LCD_contrast(unsigned char contrast);
void LCD_pointer(unsigned char enable);
void LCD_backspace(void);
void LCD_border(void);
void LCD_splash(void);


#endif  // _PCD8544_LCD_H_
